routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
Route::get('lang/{lang}', ['as' => 'lang.switch', 'uses' => 'LanguageController@switchLang']);

Route::get('/barcode', function() {
	return view('admin.barcode');
});
Route::get('/', 'Admin\AdminLoginController@index');
Route::post('/admin/login', 'Admin\AdminLoginController@attemptLogin');
Route::resource('/forgot-password', 'Admin\ForgotPasswordController');
Route::any('send-email', 'Admin\ForgotPasswordController@sendEmail');
Route::get('password-reset/{token}', 'Admin\ForgotPasswordController@resetPassword');
Route::any('resetPassword', 'Admin\ForgotPasswordController@resetAdminPassword');
Route::post('/states/country', 'Admin\StateController@getStatesByCountry')->name('states.country');

#Admin authenticated route
Route::group(['middleware' => ['admin'], 'prefix'=>'admin', 'namespace' => 'Admin'], function() {
	Route::get('/dashboard', 'AdminDashboardController@index')->name('admin.dashboard');
	Route::get('/my-profile', 'AdminLoginController@editProfile')->name('admin.my.profile');
	Route::post('/my/profile/{id}', 'AdminLoginController@updateProfile')->name('admin.myprofile');
	Route::get('/logout', 'AdminLoginController@logout');

	#Country Routes
	Route::resource('/countries', 'CountryController');
	Route::post('/countries/status-update', 'CountryController@countryEnableDisabled')->name('countries.status');

	# currency Routes
	Route::resource('/currencies', 'CurrencyController');
	Route::post('/currencies/status-update', 'CurrencyController@currencyEnableDisabled')->name('currencies.status');

	#State Routes
	Route::resource('/states', 'StateController');
	Route::post('/states/status-update', 'StateController@stateEnableDisabled')->name('states.status');

	#User Routes
	Route::resource('/users', 'UserController');
	Route::post('/users/status-update', 'UserController@userEnableDisabled')->name('users.status');

	#Brand Routes
	Route::resource('/brands', 'BrandController');
	Route::post('/brands/status-update', 'BrandController@brandEnableDisabled')->name('brands.status');

	#Color Routes
	Route::resource('/colors', 'ColorController');
	Route::post('/colors/status-update', 'ColorController@colorEnableDisabled')->name('colors.status');

	#Models Routes
	Route::resource('/models', 'ModalController');
	Route::post('/models/status-update', 'ModalController@modelEnableDisabled')->name('models.status');

	#Company Routes
	Route::resource('/company', 'CompanyController');
	Route::post('/company/status-update', 'CompanyController@companyEnableDisabled')->name('company.status');
	Route::post('/company/email-check', 'CompanyController@emailCheck')->name('company.email-check');
	Route::get('/company-parking/{parkingId}/details', 'CompanyController@showCompanyParkingSpace')->name('company-parkings.show-details');
	// Route::resource('/company-parking', 'CompanyParkingController');
	// Route::get('/company-parking/{id}/add', 'CompanyParkingController@addParking')->name('company-parking.add');

	#Washer Routes
	Route::resource('/washer', 'WasherManController');
	Route::post('/washer/email-check', 'WasherManController@emailCheck')->name('washer.email-check');
	Route::post('/washer/mobile-check', 'WasherManController@mobileCheck')->name('washer.mobile-check');
	Route::post('/washer/status-update', 'WasherManController@washerEnableDisabled')->name('washer.status');
	Route::resource('/washer-company-allot', 'WasherCompanyAllotController');

	# credential generate
	Route::get('company/{id}/generate-credential', 'CompanyController@generateCompanyCredential')->name('company.generate-credential');
	Route::post('company/{id}/generate-credential', 'CompanyController@generateCredential')->name('company.generate-credential');
	
	#Discount Routes
	Route::resource('discount', 'DiscountController');
	Route::any('fetchCompanyId', 'DiscountController@fetchCompanyId');
	Route::any('openDiscounUpdate', 'DiscountController@openDiscountUpdate');
	Route::post('/discount/status-update', 'DiscountController@statusUpdate')->name('discount.status');

	#Promocodes Routes
	Route::resource('promocode', 'PromocodeController');
	// Route::any('promocode/fetchCompanyId', 'PromocodeController@fetchCompanyId');
	Route::any('openPromocodeUpdate', 'PromocodeController@openPromocodeUpdate');
	Route::post('/promocode/status-update', 'PromocodeController@statusUpdate')->name('promocode.status');

	# popularspace Routes
	Route::resource('popular-places', 'PopularPlaceController');

	#Routes for Commission
	Route::resource('commission', 'CommissionController');
	Route::any('OpenEditCommission', 'CommissionController@OpenEditCommission');
});

Route::group(['prefix' => 'company', 'namespace' => 'Company'], function() {
	Route::get('/', 'CompanyLoginController@index')->name('company.login');
	Route::post('/login', 'CompanyLoginController@attemptLogin')->name('company.attempt.login');
	Route::get('/forgot-password', 'ForgotPasswordController@index')->name('company.forgot-password.index');
	Route::any('send-email', 'ForgotPasswordController@sendEmail')->name('company.send-email');
	Route::get('password-reset/{token}', 'ForgotPasswordController@resetPassword');
	Route::any('resetPassword', 'ForgotPasswordController@resetCompanyPassword');

	Route::group(['middleware' => 'company'], function() {
		Route::get('/logout', 'CompanyLoginController@logout')->name('company.logout');
		Route::get('dashboard', 'DashboardController@index')->name('company.dashboard.index');

		# Company Parking Route
		Route::resource('company-parkings', 'CompanyParkingController');
		Route::post('/parking/status-update', 'CompanyParkingController@companyParkingEnableDisabled')->name('company-parking.status');

		# Company Discount Route
		Route::resource('company-discount', 'DiscountController');
		Route::any('openDiscounUpdate', 'DiscountController@openDiscountUpdate');
		Route::post('/discount/status-update', 'DiscountController@statusUpdate')->name('company-discount.status');

		# Company Promocode Route
		Route::resource('company-promocodes', 'PromoCodeController');
		Route::any('promocode/{id}/openDiscounUpdate', 'PromoCodeController@openPromocodeUpdate')->name('promocode.openPromocodeUpdate');
		Route::post('/promocode/status-update', 'PromoCodeController@statusUpdate')->name('company-promocode.status');

		# Event Routes
		Route::resource('events', 'EventController');
		Route::post('/events/status-update', 'EventController@eventEnableDisabled')->name('events.status');

		# Employee Routes
		Route::resource('/employees', 'EmployeeController');
		Route::post('/employees/email-check', 'EmployeeController@emailCheck')->name('employees.email-check');
		Route::post('/employees/mobile-check', 'EmployeeController@mobileCheck')->name('employees.mobile-check');
		Route::post('/employees/status-update', 'EmployeeController@employeeEnableDisabled')->name('employees.status');
		Route::get('/employees/{id}/parking-allot', 'EmployeeController@employeeParkingAllot')->name('employees.parking-allot');
		Route::post('/employees/{id}/parking-allocate', 'EmployeeController@employeeParkingAllocate')->name('employees.parking-allocate');

		# Company parking Space Route
		Route::get('company-parkings/{parking_id}/parking-space', 'CompanyParkingController@createSpaceOfParking')->name('parking-space.create');
		Route::post('parking-space/set-up-space', 'CompanyParkingController@setUpSpace')->name('parking-space.setup-space');
		Route::post('parking-space/space-description', 'CompanyParkingController@spaceDescription')->name('parking.space-description');
		Route::post('parking-space/space-feature', 'CompanyParkingController@parkingFeature')->name('parking.space-feature');
		Route::post('parking-space/mark-out-space', 'CompanyParkingController@markOutSpace')->name('parking-space.mark-out-space');
		Route::post('parking-space/payout-setting', 'CompanyParkingController@payoutSetting')->name('parking-space.payout-setting');
		Route::post('parking-space/advance-space-setting', 'CompanyParkingController@advanceSpaceSetting')->name('parking-space.advance-space-setting');
		Route::post('parking-space/parking-driver-feature', 'CompanyParkingController@parkingDriverFeature')->name('parking-space.parking-driver-feature');
		Route::post('parking-space/parking-washer-feature', 'CompanyParkingController@parkingWasherFeature')->name('parking-space.parking-washer-feature');
		Route::post('parking-space/parking-booking-feature', 'CompanyParkingController@parkingBookingFeature')->name('parking-space.parking-booking-feature');
		Route::post('parking-space/parking-subscription-feature', 'CompanyParkingController@parkingSubscriptionFeature')->name('parking-space.parking-subscription-feature');

		#Booking management Routes
		Route::resource('onGoingbooking', 'BookingController');
		Route::get('/onGoingbooking/show/{id}/{type}','BookingController@show')->name('onGoingbooking.show');
		Route::post('/onGoingbooking/export','BookingController@exportdata')->name('onGoingbooking.export');
	});
});

app/Models/Color.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;

class Color extends Model
{
	# user softdeletes.
    use SoftDeletes;

  	# define table.
  	protected $table 	= 	'colors';

  	# define fillable fildes
  	protected $fillable = 	[
  		'name',
  		'code',
  		'status'
  	];

  	/**
    * The attributes that should be cast to native types.
    *
    * @var array
	*/
	protected $casts = [
	  'created_at'    => 'datetime',
	  'status'        => 'boolean',
	];

  	/**
     * @method Scope a query to only include active color.
     * @param  \Illuminate\Database\Eloquent\Builder  $query
     * @return \Illuminate\Database\Eloquent\Builder
	*/
	public function scopeActive($query)
	{
	  return $query->where('status', 1);
	}
}

app/Http/Controllers/Admin/ColorController.php
<?php

namespace App\Http\Controllers\Admin;

use App\Models\Color;
use Illuminate\Http\Request;
use App\Http\Controllers\Controller;

class ColorController extends Controller
{
    # Bind the Color Model
    protected $colors;

    # Bind the view of Color
    protected $view = 'admin.colors.';
    
    /**
     * Define the constructor of controller.
     *
     * @return Bind the Color Model
     */    
    public function __construct(Color $colors)
    {
        $this->colors = $colors;
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        # get the all colors
        $colors = $this->colors->all();

        # display the listing of color
        return view($this->view.'index', compact('colors'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        # Display the create color page
        return view($this->view.'create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        # check validation
        $request->validate([
            'name' => 'required'
        ]);

        # Gather the form data
        $colorData  = [
            'name' => $request->get('name')
        ];

        # create color
        $this->colors->create($colorData);

        # redirect back to create page with message.
        return redirect()->back()->with(['success_message' => 'Color Created Successfully!']);
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        // Code
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        # get the color details
        $color = $this->colors->findOrFail($id);

        # Display the edit color page
        return view($this->view.'edit', compact('color'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        # check validation
        $request->validate([
            'name' => 'required'
        ]);

        # Gather the form data
        $colorData  = [
            'name' => $request->get('name')
        ];

        # update color
        $this->colors->findOrFail($id)->update($colorData);

        # redirect back to edit page with message.
        return redirect()->back()->with(['success_message' => 'Color Updated Successfully!']);
    }

    /**
     * Update Status the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function colorEnableDisabled(Request $request)
    {
        # get color details
        $color = $this->colors->findOrFail($request->get('color_id'));

        # define $color data as an array
        $colorData = [];
        $message = '';

        # check color status
        if ($color->status == '1') {
            $colorData['status']  = '0';
            $message = "Color Inactive Successfully!";
        } else {
            $colorData['status']  = '1';
            $message = "Color Active Successfully!";
        }

        # update color status
        $color->update($colorData);

        # redirect back to listing page of state with message_success
        return response()->json(['status' => 200, 'success_message' => $message]);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        //
    }
}

resources/views/admin/colors/create.blade.php
@extends('layouts.main-layout')
@section('content')

<!-- content-wrapper start -->
<div class="content-wrapper">
  <div class="page-header">
    <h3 class="page-title">
        <span class="page-title-icon bg-gradient-primary text-white mr-2">
          <i class="mdi mdi-account"></i>
        </span> Color Create 
    </h3>
    <nav aria-label="breadcrumb">
        <ul class="breadcrumb">
          <li class="breadcrumb-item active" aria-current="page">
            <a href="{{ route('colors.index') }}">
               <i class="mdi mdi-arrow-left icon-sm text-primary align-middle mr-1"></i> Back
            </a>
          </li>
        </ul>
    </nav>
  </div>
  <div class="row">
    <div class="col-md-12">
      <div class="card">
        <div class="card-body">
          <form class="cmxform" id="signupForm" method="post" action="{{ route('colors.store') }}">
            @csrf
            <fieldset>
              <div class="form-group">
                <label for="username">Color Name</label>
                <input id="username" class="form-control" placeholder="Color Name" name="name" type="text">
                <span class="text-danger">{{ $errors->first('name') }}</span>
              </div>
              <button type="submit" class="btn btn-primary">Create</button>
            </fieldset>
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
@stop

resources/views/admin/colors/edit.blade.php
@extends('layouts.main-layout')
@section('content')

<!-- content-wrapper start -->
<div class="content-wrapper">
  <div class="page-header">
    <h3 class="page-title">
        <span class="page-title-icon bg-gradient-primary text-white mr-2">
          <i class="mdi mdi-account"></i>
        </span> Edit Color 
    </h3>
    <nav aria-label="breadcrumb">
        <ul class="breadcrumb">
          <li class="breadcrumb-item active" aria-current="page">
            <a href="{{ route('colors.index') }}">
               <i class="mdi mdi-arrow-left icon-sm text-primary align-middle mr-1"></i> Back
            </a>
          </li>
        </ul>
    </nav>
  </div>
  <div class="row">
    <div class="col-md-12">
      <div class="card">
        <div class="card-body">
          <form class="cmxform" id="signupForm" method="post" action="{{ route('colors.update', [$color->id]) }}">
            @csrf
            @method('patch')
            <fieldset>
              <div class="form-group">
                <label for="username">Color Name</label>
                <input id="username" class="form-control" placeholder="Color Name" value="{{ $color->name ?? '' }}" name="name" type="text">
                <span class="text-danger">{{ $errors->first('name') }}</span>
              </div>
              <button type="submit" class="btn btn-primary">Update</button>
            </fieldset>
          </form>
        </div>
      </div>
    </div>
  </div>
</div>
@stop

resources/views/admin/colors/index.blade.php
@extends('layouts.main-layout')
@section('content')

<!-- content-wrapper start -->
<div class="content-wrapper">
  <div class="page-header">
    <!-- <h3 class="page-title"> Brand </h3> -->
    

    <h3 class="page-title">
        <span class="page-title-icon bg-gradient-primary text-white mr-2">
          <i class="mdi mdi-account"></i>
        </span> Colors 
    </h3>
    <nav aria-label="breadcrumb">
        <ol class="breadcrumb">
          <li class="breadcrumb-item"><a href="{{ route('admin.dashboard') }}"><i class="mdi mdi-home"></i></a></li>
          <li class="breadcrumb-item active" aria-current="page">Colors</li>
        </ol>
    </nav>
  </div>
  <div class="row">
    <div class="col-md-12 stretch-card grid-margin">
      <div class="card card-img-holder">
        <div class="card-body">
          <div class="table-responsive">
            <a href="{{ route('colors.create') }}" class="btn float-left btn-sm mr-1 btn-gradient-primary mb-3">Add Color</a>
            <table class="table table-bordered datatable-color">
              <thead>
                <tr>
                  <th>Name</th>
                  <th>Action</th>
                </tr>
              </thead>
              <tbody>
                @foreach($colors as $color)
                <tr>
                  <td>{{ $color->name ?? '' }}</td>
                  <td>
                    <a href="{{ route('colors.edit', [$color->id]) }}" class="btn btn-sm btn-gradient-primary mb-3">Edit</a>
                    <label class="togglebox toggleStatus ml-1" data-color-id="{{ $color->id ?? ''}}">
                      <input type="checkbox" @if($color->status == 1) checked="checked" @endif name="block_unblock" hidden=""/>
                      <span class="label-text"></span>
                    </label>
                  </td>
                </tr>
                @endforeach
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
@stop

@section('js-content')

  <script type="text/javascript">
    
    $('.datatable-color').DataTable({
      dom: 'Bfrtip',
      buttons: [
       {
          extend: 'copy',
          exportOptions: {
            columns: [0]
          }
       },
       {
          extend: 'csv',
          exportOptions: {
            columns: [0]
          }
       },
       {
          extend: 'excel',  
          exportOptions: {
            columns: [0]
          }
       },
       {
          extend: 'print',
          exportOptions: {
            columns: [0]
          }
       }
      ]
    });
    $(document).on('change', 'label.toggleStatus', function() {
      var colorId = $(this).data('color-id')

      $.ajax({
        method: 'POST',
        url: "{{ route('colors.status') }}",
        data: {color_id: colorId},
        dataType: 'json',
        success: function(response) {
          if (response.status == 200) {
            swal(response.success_message)
          }
        }
      })
    })
  </script>
@stop